<?php

class GetWebObject {

   var $ip  = "";
   var $host  = "";
   var $port  = "";
   var $path   = "";
   var $cookies   = "";
   var $postdata   = "";
   var $header = array();
   var $content = "";

   function GetWebObject($host, $port, $path, $cookies="", $postdata="") {

      $this->ip = gethostbyname($host) ;
      $this->host = $host;
      $this->port = $port;
      $this->path = $path;
      $this->cookies = $cookies;
      $this->postdata = $postdata;
      $this->fetch();

   }

   function fetch() {

      $timeout = 30;
      $fp = fsockopen ($this->ip, $this->port,&$errno, &$errstr, $timeout);
   
      if(!$fp) { return ""; }
   
      $header_done=false;
   
      if (empty($this->postdata))
      {
         $request = "GET ".$this->path." HTTP/1.0\r\n";
      }
      else
      {
         $request = "POST ".$this->path." HTTP/1.0\r\n";
      }

      $request .= "Accept: image/gif, image/jpeg, */*\r\n";
      $request .= "Accept-Language: en-us\r\n";
      $request .= "User-Agent: Mozilla/4.0\r\n";
      $request .= "Host: ".$this->host."\r\n";
      if (!empty($this->cookies))
      {
         $request .= "Cookie: ".$this->cookies."\r\n";
      }
      
      $request .= "Cache-Control: no-cache\r\n";

      if (!empty($this->postdata))
      {
         
         $request .= "Content-Type: application/x-www-form-urlencoded\r\n";
         $request .= "Content-Length: " . strlen($this->postdata) . "\r\n";
      }

      $request .= "Connection: Close\r\n";

      $request .= "\r\n";

      $return = '';

      socket_set_timeout($fp, $timeout - 20);


      if (empty($this->postdata))
      {
         @fputs ($fp, $request);
      }
      else
      {
         @fputs ($fp, $request . $this->postdata);
      }
   
      $line = fgets ($fp, 1024);
      if (trim($line)=="") $line = fgets ($fp, 1024);

      $this->header["status"] = trim($line);
   
      $i = 0; echo ".";
      while (!feof($fp) && $i<15000 ) {

         $line = fgets ( $fp, 1024 );
         if ($line == "") 
         {
            echo "+";
            break;
         }

         if($header_done) {
            $this->content .= $line;
         }
         else {
            if($line == "\r\n") {
               $header_done=true; echo ".";
            }
            else {
               $data = explode(": ",$line);
               $data[0] = trim($data[0]);
               if (substr($data[0],0,4) == "HTTP")
               {
                  $this->header["status"] = $data[0];
               }
               else
               {
                   $this->header[$data[0]] = trim($data[1]);
               }
            }
         } 
         $i++;
      }
      echo ".";
      @fclose ($fp);

   }
 

   function get_header() { 
      return($this->header);
   }

 
   function get_content() { 
      return($this->content);
   }

}

?>
