/* Here we will store our links / domains /

CREATE TABLE `yahoo_links` (
`id` int(11) NOT NULL auto_increment,
`url` varchar(255) NOT NULL default '',
`host` varchar(200) NOT NULL default '',
`title` varchar(255) NOT NULL default '',
`description` text NOT NULL,
`expired` varchar(100) NOT NULL default '',
`whois` text NOT NULL,
`additional` varchar(100) NOT NULL default '',
`category` varchar(255) NOT NULL default '',
PRIMARY KEY (`id`),
KEY `id` (`id`),
KEY `url` (`url`),
KEY `category` (`category`),
KEY `expired` (`expired`),
KEY `additional` (`additional`)
) TYPE=MyISAM ;


/* List of parsed yahoo links */

CREATE TABLE `yahoo_parsedurl` (
`id` int(11) NOT NULL auto_increment,
`url` varchar(255) NOT NULL default '',
KEY `id` (`id`)
) TYPE=MyISAM ;

/* List of non parsed yahoo links */

CREATE TABLE `yahoo_starturl` (
`id` int(11) NOT NULL auto_increment,
`url` varchar(255) NOT NULL default '',
KEY `id` (`id`),
KEY `url` (`url`)
) TYPE=MyISAM ;

/* List of start links for yahoo catalog */

insert into yahoo_starturl (url) values ('/Arts/');
insert into yahoo_starturl (url) values ('/Business_and_Economy/');
insert into yahoo_starturl (url) values ('/Computers_and_Internet/');
insert into yahoo_starturl (url) values ('/Education/');
insert into yahoo_starturl (url) values ('/Government/');
insert into yahoo_starturl (url) values ('/Health/');
insert into yahoo_starturl (url) values ('/News_and_Media/');
insert into yahoo_starturl (url) values ('/Recreation/');
insert into yahoo_starturl (url) values ('/Reference/');
insert into yahoo_starturl (url) values ('/Science/');
insert into yahoo_starturl (url) values ('/Social_Science/');
insert into yahoo_starturl (url) values ('/Society_and_Culture/');
insert into yahoo_starturl (url) values ('/Entertainment/');


